local LevelsScreen = {}

local level5_Animation
local level4_Animation
local level1_Animation
local backButton_Sprite
local levelsBackground_Sprite
local level3_Animation
local level2_Animation
local screenHolder
local buttonPressEnabled
local menuInCompleted
local menuOut
local menuOutCompleted
local addButtonEventListeners
local removeButtonEventListeners

local mTimerList
local timerCount

local level5_AnimationSpriteListener
local level4_AnimationSpriteListener
local level1_AnimationSpriteListener
local level3_AnimationSpriteListener
local level2_AnimationSpriteListener

local destroy_level5_Animation
local destroy_level4_Animation
local destroy_level1_Animation
local destroy_backButton_Sprite
local destroy_levelsBackground_Sprite
local destroy_level3_Animation
local destroy_level2_Animation

local camera = {}
camera.boundedObject = nil
camera.leftBound = display.contentWidth * 0
camera.rightBound = display.contentWidth * 1
camera.topBound = display.contentHeight * 0
camera.bottomBound = display.contentHeight * 1
camera.initialHolderLeft = 0
camera.initialHolderRight = 0
camera.initialHolderTop = 0
camera.initialHolderBottom = 0
camera.initialHolderWidth = 0
camera.initialHolderHeight = 0

local leftBoundValue = 0
local rightBoundValue = 0
local topBoundValue = 0
local bottomBoundValue = 0

destroy_level5_Animation = function ()
	display.remove(level5_Animation)
	level5_Animation = nil
end

destroy_level4_Animation = function ()
	display.remove(level4_Animation)
	level4_Animation = nil
end

destroy_level1_Animation = function ()
	display.remove(level1_Animation)
	level1_Animation = nil
end

destroy_backButton_Sprite = function ()
	display.remove(backButton_Sprite)
	backButton_Sprite = nil
end

destroy_levelsBackground_Sprite = function ()
	display.remove(levelsBackground_Sprite)
	levelsBackground_Sprite = nil
end

destroy_level3_Animation = function ()
	display.remove(level3_Animation)
	level3_Animation = nil
end

destroy_level2_Animation = function ()
	display.remove(level2_Animation)
	level2_Animation = nil
end

level5_AnimationSpriteListener = function (event)
	if event.phase == "began" then
	elseif event.phase == "loop" then
	elseif event.phase == "ended" then
	end
end

level4_AnimationSpriteListener = function (event)
	if event.phase == "began" then
	elseif event.phase == "loop" then
	elseif event.phase == "ended" then
	end
end

level1_AnimationSpriteListener = function (event)
	if event.phase == "began" then
	elseif event.phase == "loop" then
	elseif event.phase == "ended" then
	end
end

level3_AnimationSpriteListener = function (event)
	if event.phase == "began" then
	elseif event.phase == "loop" then
	elseif event.phase == "ended" then
	end
end

level2_AnimationSpriteListener = function (event)
	if event.phase == "began" then
	elseif event.phase == "loop" then
	elseif event.phase == "ended" then
	end
end

local startingXPos = 0
local startingYPos = 0
local function onScreenTouch(event)
	if event.phase == "began" then
		startingXPos = event.x
		startingYPos = event.y
	elseif event.phase == "moved" then
	elseif event.phase == "ended" or event.phase == "cancelled" then

		if event.x - startingXPos < -20 and math.abs(event.y - startingYPos) < math.abs(event.x - startingXPos) then
		end

		if event.x - startingXPos > 20 and math.abs(event.y - startingYPos) < math.abs(event.x - startingXPos) then
		end

		if event.y - startingYPos < -20 and math.abs(event.x - startingXPos) < math.abs(event.y - startingYPos) then
		end

		if event.y - startingYPos > 20 and math.abs(event.x - startingXPos) < math.abs(event.y - startingYPos) then
		end
	end
end

local function onAccelerometer(event)
end

local function onCollision( event )
	if ( event.phase == "began" ) then
	elseif ( event.phase == "ended" ) then
	end
end

local function level5_AnimationTouchHandler(self, event)
	if event.phase == "began" then
		event.target.pressed = true
		display.getCurrentStage():setFocus( event.target, event.id )
		event.target.focus = true
	elseif event.phase == "moved" then
	elseif (event.phase == "ended" or event.phase == "cancelled") and event.target.pressed == true then
		if event.target.focus ~= true then
			return false
		end
		display.getCurrentStage():setFocus( event.target, nil )
		if var_isLevel5Locked == false then
			menuOut ( Screen5MenuID )		end

	end
	return true
end

local function level4_AnimationTouchHandler(self, event)
	if event.phase == "began" then
		event.target.pressed = true
		display.getCurrentStage():setFocus( event.target, event.id )
		event.target.focus = true
	elseif event.phase == "moved" then
	elseif (event.phase == "ended" or event.phase == "cancelled") and event.target.pressed == true then
		if event.target.focus ~= true then
			return false
		end
		display.getCurrentStage():setFocus( event.target, nil )
		if var_isLevel4Locked == false then
			menuOut ( Screen4MenuID )		end

	end
	return true
end

local function level1_AnimationTouchHandler(self, event)
	if event.phase == "began" then
		event.target.pressed = true
		display.getCurrentStage():setFocus( event.target, event.id )
		event.target.focus = true
	elseif event.phase == "moved" then
	elseif (event.phase == "ended" or event.phase == "cancelled") and event.target.pressed == true then
		if event.target.focus ~= true then
			return false
		end
		display.getCurrentStage():setFocus( event.target, nil )
		menuOut ( Screen1MenuID )
	end
	return true
end

local function backButton_SpriteTouchHandler(self, event)
	if event.phase == "began" then
		event.target.pressed = true
		display.getCurrentStage():setFocus( event.target, event.id )
		event.target.focus = true
	elseif event.phase == "moved" then
	elseif (event.phase == "ended" or event.phase == "cancelled") and event.target.pressed == true then
		if event.target.focus ~= true then
			return false
		end
		display.getCurrentStage():setFocus( event.target, nil )
		menuOut ( MainScreenMenuID )
	end
	return true
end

local function level3_AnimationTouchHandler(self, event)
	if event.phase == "began" then
		event.target.pressed = true
		display.getCurrentStage():setFocus( event.target, event.id )
		event.target.focus = true
	elseif event.phase == "moved" then
	elseif (event.phase == "ended" or event.phase == "cancelled") and event.target.pressed == true then
		if event.target.focus ~= true then
			return false
		end
		display.getCurrentStage():setFocus( event.target, nil )
		if var_isLevel3Locked == false then
			menuOut ( Screen3MenuID )		end

	end
	return true
end

local function level2_AnimationTouchHandler(self, event)
	if event.phase == "began" then
		event.target.pressed = true
		display.getCurrentStage():setFocus( event.target, event.id )
		event.target.focus = true
	elseif event.phase == "moved" then
	elseif (event.phase == "ended" or event.phase == "cancelled") and event.target.pressed == true then
		if event.target.focus ~= true then
			return false
		end
		display.getCurrentStage():setFocus( event.target, nil )
		if var_isLevel2Locked == false then
			menuOut ( Screen2MenuID )		end

	end
	return true
end

local function loadScreen ()
	screenHolder = display.newGroup()
	screenHolder.x = 0
	screenHolder.y = 0
	local screenHolderRect = display.newRect(screenHolder, 0, 0, display.contentWidth, display.contentHeight)
	screenHolderRect.alpha = 0

	cameraHolder = display.newGroup()
	cameraHolder.x = 0
	cameraHolder.y = 0

	buttonPressEnabled = true

	display.remove(level5_Animation)
	level5_Animation = nil
	level5_Animation = display.newSprite(spriteSheets["levelsSpriteSheet503x503"], spriteSets["levelsSpriteSheet503x503"])
	level5_Animation.anchorX = 0.5
	level5_Animation.anchorY = 0.5
	level5_Animation:setSequence("level5")
	level5_Animation:play()
	level5_Animation:addEventListener("sprite", level5_AnimationSpriteListener)
	level5_Animation.hasBody = false
	level5_Animation.x = 1288.3999999999942 + 0 + 0
	level5_Animation.y = 1284.800000000003 + 0 + 0
	level5_Animation.xScale = 1
	level5_Animation.yScale = 1
	level5_Animation.alpha = 1
	level5_Animation.rotation = 0
	level5_Animation.xDirection = 1
	level5_Animation.yDirection = 0
	level5_Animation.xSpeed = 0
	level5_Animation.ySpeed = 0
	level5_Animation.xCurrentSpeed = 0
	level5_Animation.yCurrentSpeed = 0
	level5_Animation.xSpeedUpdated = false
	level5_Animation.ySpeedUpdated = false
	level5_Animation.rotationUpdated = false
	level5_Animation.directionUpdated = false
	level5_Animation.spawnIndex = 1

	display.remove(level4_Animation)
	level4_Animation = nil
	level4_Animation = display.newSprite(spriteSheets["levelsSpriteSheet503x503"], spriteSets["levelsSpriteSheet503x503"])
	level4_Animation.anchorX = 0.5
	level4_Animation.anchorY = 0.5
	level4_Animation:setSequence("level4")
	level4_Animation:play()
	level4_Animation:addEventListener("sprite", level4_AnimationSpriteListener)
	level4_Animation.hasBody = false
	level4_Animation.x = 257.1999999999971 + 0 + 0
	level4_Animation.y = 1277.5999999999983 + 0 + 0
	level4_Animation.xScale = 1
	level4_Animation.yScale = 1
	level4_Animation.alpha = 1
	level4_Animation.rotation = 0
	level4_Animation.xDirection = 1
	level4_Animation.yDirection = 0
	level4_Animation.xSpeed = 0
	level4_Animation.ySpeed = 0
	level4_Animation.xCurrentSpeed = 0
	level4_Animation.yCurrentSpeed = 0
	level4_Animation.xSpeedUpdated = false
	level4_Animation.ySpeedUpdated = false
	level4_Animation.rotationUpdated = false
	level4_Animation.directionUpdated = false
	level4_Animation.spawnIndex = 1

	display.remove(level1_Animation)
	level1_Animation = nil
	level1_Animation = display.newSprite(spriteSheets["levelsSpriteSheet503x503"], spriteSets["levelsSpriteSheet503x503"])
	level1_Animation.anchorX = 0.5
	level1_Animation.anchorY = 0.5
	level1_Animation:setSequence("level1")
	level1_Animation:play()
	level1_Animation:addEventListener("sprite", level1_AnimationSpriteListener)
	level1_Animation.hasBody = false
	level1_Animation.x = 254.79999999999563 + 0 + 0
	level1_Animation.y = 258.40000000000146 + 0 + 0
	level1_Animation.xScale = 1
	level1_Animation.yScale = 1
	level1_Animation.alpha = 1
	level1_Animation.rotation = 0
	level1_Animation.xDirection = 1
	level1_Animation.yDirection = 0
	level1_Animation.xSpeed = 0
	level1_Animation.ySpeed = 0
	level1_Animation.xCurrentSpeed = 0
	level1_Animation.yCurrentSpeed = 0
	level1_Animation.xSpeedUpdated = false
	level1_Animation.ySpeedUpdated = false
	level1_Animation.rotationUpdated = false
	level1_Animation.directionUpdated = false
	level1_Animation.spawnIndex = 1

	display.remove(backButton_Sprite)
	backButton_Sprite = nil
	backButton_Sprite = display.newImageRect("backButton.png", 503, 503)
	backButton_Sprite.anchorX = 0.5
	backButton_Sprite.anchorY = 0.5
	backButton_Sprite.hasBody = false
	backButton_Sprite.x = 1795.5999999999983 + 0 + 0
	backButton_Sprite.y = 1277.5999999999983 + 0 + 0
	backButton_Sprite.xScale = 1
	backButton_Sprite.yScale = 1
	backButton_Sprite.alpha = 1
	backButton_Sprite.rotation = 0
	backButton_Sprite.xDirection = 1
	backButton_Sprite.yDirection = 0
	backButton_Sprite.xSpeed = 0
	backButton_Sprite.ySpeed = 0
	backButton_Sprite.xCurrentSpeed = 0
	backButton_Sprite.yCurrentSpeed = 0
	backButton_Sprite.xSpeedUpdated = false
	backButton_Sprite.ySpeedUpdated = false
	backButton_Sprite.rotationUpdated = false
	backButton_Sprite.directionUpdated = false
	backButton_Sprite.spawnIndex = 1

	display.remove(levelsBackground_Sprite)
	levelsBackground_Sprite = nil
	levelsBackground_Sprite = display.newImageRect("levelsBackground.png", 2048, 1536)
	levelsBackground_Sprite.anchorX = 0.5
	levelsBackground_Sprite.anchorY = 0.5
	levelsBackground_Sprite.hasBody = false
	levelsBackground_Sprite.x = 1024 + 0 + 0
	levelsBackground_Sprite.y = 768 + 0 + 0
	levelsBackground_Sprite.xScale = 1
	levelsBackground_Sprite.yScale = 1
	levelsBackground_Sprite.alpha = 1
	levelsBackground_Sprite.rotation = 0
	levelsBackground_Sprite.xDirection = 1
	levelsBackground_Sprite.yDirection = 0
	levelsBackground_Sprite.xSpeed = 0
	levelsBackground_Sprite.ySpeed = 0
	levelsBackground_Sprite.xCurrentSpeed = 0
	levelsBackground_Sprite.yCurrentSpeed = 0
	levelsBackground_Sprite.xSpeedUpdated = false
	levelsBackground_Sprite.ySpeedUpdated = false
	levelsBackground_Sprite.rotationUpdated = false
	levelsBackground_Sprite.directionUpdated = false
	levelsBackground_Sprite.spawnIndex = 1

	display.remove(level3_Animation)
	level3_Animation = nil
	level3_Animation = display.newSprite(spriteSheets["levelsSpriteSheet503x503"], spriteSets["levelsSpriteSheet503x503"])
	level3_Animation.anchorX = 0.5
	level3_Animation.anchorY = 0.5
	level3_Animation:setSequence("level3")
	level3_Animation:play()
	level3_Animation:addEventListener("sprite", level3_AnimationSpriteListener)
	level3_Animation.hasBody = false
	level3_Animation.x = 776.4499999999971 + 0 + 0
	level3_Animation.y = 775.1999999999971 + 0 + 0
	level3_Animation.xScale = 1
	level3_Animation.yScale = 1
	level3_Animation.alpha = 1
	level3_Animation.rotation = 0
	level3_Animation.xDirection = 1
	level3_Animation.yDirection = 0
	level3_Animation.xSpeed = 0
	level3_Animation.ySpeed = 0
	level3_Animation.xCurrentSpeed = 0
	level3_Animation.yCurrentSpeed = 0
	level3_Animation.xSpeedUpdated = false
	level3_Animation.ySpeedUpdated = false
	level3_Animation.rotationUpdated = false
	level3_Animation.directionUpdated = false
	level3_Animation.spawnIndex = 1

	display.remove(level2_Animation)
	level2_Animation = nil
	level2_Animation = display.newSprite(spriteSheets["levelsSpriteSheet503x503"], spriteSets["levelsSpriteSheet503x503"])
	level2_Animation.anchorX = 0.5
	level2_Animation.anchorY = 0.5
	level2_Animation:setSequence("level2")
	level2_Animation:play()
	level2_Animation:addEventListener("sprite", level2_AnimationSpriteListener)
	level2_Animation.hasBody = false
	level2_Animation.x = 1286 + 0 + 0
	level2_Animation.y = 265.65000000000146 + 0 + 0
	level2_Animation.xScale = 1
	level2_Animation.yScale = 1
	level2_Animation.alpha = 1
	level2_Animation.rotation = 0
	level2_Animation.xDirection = 1
	level2_Animation.yDirection = 0
	level2_Animation.xSpeed = 0
	level2_Animation.ySpeed = 0
	level2_Animation.xCurrentSpeed = 0
	level2_Animation.yCurrentSpeed = 0
	level2_Animation.xSpeedUpdated = false
	level2_Animation.ySpeedUpdated = false
	level2_Animation.rotationUpdated = false
	level2_Animation.directionUpdated = false
	level2_Animation.spawnIndex = 1

	cameraHolder:insert(levelsBackground_Sprite)
	cameraHolder:insert(backButton_Sprite)
	cameraHolder:insert(level1_Animation)
	cameraHolder:insert(level2_Animation)
	cameraHolder:insert(level3_Animation)
	cameraHolder:insert(level4_Animation)
	cameraHolder:insert(level5_Animation)

	screenHolder:insert( cameraHolder )
	screenHolder.anchorX = 0
	screenHolder.anchorY = 0

	leftBoundObject = levelsBackground_Sprite
	leftBoundValue = 0
	rightBoundObject = levelsBackground_Sprite
	rightBoundValue = 2048
	topBoundObject = levelsBackground_Sprite
	topBoundValue = 0
	bottomBoundObject = level5_Animation
	bottomBoundValue = 1536.3

	camera.initialHolderLeft = leftBoundValue
	camera.initialHolderRight = camera.initialHolderLeft + cameraHolder.width
	camera.initialHolderTop = topBoundValue
	camera.initialHolderBottom = camera.initialHolderTop + cameraHolder.height
	camera.initialHolderWidth = cameraHolder.width
	camera.initialHolderHeight = cameraHolder.height
end

function LevelsScreen.addButtonEventListeners ()
	level5_Animation.touch = level5_AnimationTouchHandler
	level5_Animation:addEventListener("touch", level5_Animation)

	level4_Animation.touch = level4_AnimationTouchHandler
	level4_Animation:addEventListener("touch", level4_Animation)

	level1_Animation.touch = level1_AnimationTouchHandler
	level1_Animation:addEventListener("touch", level1_Animation)

	backButton_Sprite.touch = backButton_SpriteTouchHandler
	backButton_Sprite:addEventListener("touch", backButton_Sprite)

	level3_Animation.touch = level3_AnimationTouchHandler
	level3_Animation:addEventListener("touch", level3_Animation)

	level2_Animation.touch = level2_AnimationTouchHandler
	level2_Animation:addEventListener("touch", level2_Animation)

end

local function onEnterFrame(event)
	deltaTime = system.getTimer() - currentTime
	if deltaTime > 1000 then
		deltaTime = 1000/60
	elseif deltaTime < 0 then
		deltaTime = 1000/60
	end
	currentTime = system.getTimer()


	if camera.boundedObject ~= nil then
		if (cameraHolder.x + camera.boundedObject.x >= camera.rightBound) then
			if cameraHolder.x + camera.initialHolderWidth + camera.initialHolderLeft > display.contentWidth then
				cameraHolder.x = camera.rightBound - camera.boundedObject.x
			end
		elseif (cameraHolder.x + camera.boundedObject.x <= camera.leftBound) then
			if cameraHolder.x + camera.initialHolderLeft < 0 then
				cameraHolder.x = camera.leftBound - camera.boundedObject.x
			end
		end

		if (cameraHolder.y + camera.boundedObject.y >= camera.bottomBound) then
			if cameraHolder.y + camera.initialHolderHeight + camera.initialHolderTop > display.contentHeight then
				cameraHolder.y = camera.bottomBound - camera.boundedObject.y
			end
		elseif (cameraHolder.y + camera.boundedObject.y <= camera.topBound) then
			if cameraHolder.y + camera.initialHolderTop < 0 then
				cameraHolder.y = camera.topBound - camera.boundedObject.y
			end
		end
	end


	if level5_Animation ~= nil then
		if level5_Animation.hasBody == true then
			local vx, vy = level5_Animation:getLinearVelocity()
			level5_Animation.xCurrentSpeed = vx
			level5_Animation.yCurrentSpeed = vy
			if level5_Animation.xSpeedUpdated == true then
				level5_Animation:setLinearVelocity(level5_Animation.xSpeed, vy)
				level5_Animation.xSpeedUpdated = false
			end
			if level5_Animation.ySpeedUpdated == true then
				local vx2, vy2 = level5_Animation:getLinearVelocity()
				level5_Animation:setLinearVelocity(vx2, level5_Animation.ySpeed)
				level5_Animation.ySpeedUpdated = false
			end
			local vx3, vy3 = level5_Animation:getLinearVelocity()
			level5_Animation.xSpeed = vx3
			level5_Animation.ySpeed = vy3
		elseif level5_Animation.hasBody == false then
			level5_Animation.x = level5_Animation.x + level5_Animation.xSpeed * deltaTime * 0.001
			level5_Animation.y = level5_Animation.y + level5_Animation.ySpeed * deltaTime * 0.001
			level5_Animation.xCurrentSpeed = level5_Animation.xSpeed
			level5_Animation.yCurrentSpeed = level5_Animation.ySpeed
		end
		if level5_Animation.xDirection == 0 and level5_Animation.yDirection == 0 then
			level5_Animation.xDirection = 1
			level5_Animation.yDirection = 0
		end
		if level5_Animation.rotationUpdated == true then
			level5_Animation.xDirection = math.cos(level5_Animation.rotation * math.pi / 180)
			level5_Animation.yDirection = math.sin(level5_Animation.rotation * math.pi / 180)
			level5_Animation.rotationUpdated = false
		end
		if level5_Animation.directionUpdated == true then
			level5_Animation.rotation = ((math.atan2(level5_Animation.yDirection, level5_Animation.xDirection) * 180 / math.pi) + 720) % 360
			level5_Animation.directionUpdated = false
		end
		local tempXDir = level5_Animation.xDirection / math.sqrt((math.pow(level5_Animation.xDirection, 2) + math.pow(level5_Animation.yDirection, 2)))
		local tempYDir = level5_Animation.yDirection / math.sqrt((math.pow(level5_Animation.xDirection, 2) + math.pow(level5_Animation.yDirection, 2)))
		level5_Animation.xDirection = tempXDir
		level5_Animation.yDirection = tempYDir
	end
	if level4_Animation ~= nil then
		if level4_Animation.hasBody == true then
			local vx, vy = level4_Animation:getLinearVelocity()
			level4_Animation.xCurrentSpeed = vx
			level4_Animation.yCurrentSpeed = vy
			if level4_Animation.xSpeedUpdated == true then
				level4_Animation:setLinearVelocity(level4_Animation.xSpeed, vy)
				level4_Animation.xSpeedUpdated = false
			end
			if level4_Animation.ySpeedUpdated == true then
				local vx2, vy2 = level4_Animation:getLinearVelocity()
				level4_Animation:setLinearVelocity(vx2, level4_Animation.ySpeed)
				level4_Animation.ySpeedUpdated = false
			end
			local vx3, vy3 = level4_Animation:getLinearVelocity()
			level4_Animation.xSpeed = vx3
			level4_Animation.ySpeed = vy3
		elseif level4_Animation.hasBody == false then
			level4_Animation.x = level4_Animation.x + level4_Animation.xSpeed * deltaTime * 0.001
			level4_Animation.y = level4_Animation.y + level4_Animation.ySpeed * deltaTime * 0.001
			level4_Animation.xCurrentSpeed = level4_Animation.xSpeed
			level4_Animation.yCurrentSpeed = level4_Animation.ySpeed
		end
		if level4_Animation.xDirection == 0 and level4_Animation.yDirection == 0 then
			level4_Animation.xDirection = 1
			level4_Animation.yDirection = 0
		end
		if level4_Animation.rotationUpdated == true then
			level4_Animation.xDirection = math.cos(level4_Animation.rotation * math.pi / 180)
			level4_Animation.yDirection = math.sin(level4_Animation.rotation * math.pi / 180)
			level4_Animation.rotationUpdated = false
		end
		if level4_Animation.directionUpdated == true then
			level4_Animation.rotation = ((math.atan2(level4_Animation.yDirection, level4_Animation.xDirection) * 180 / math.pi) + 720) % 360
			level4_Animation.directionUpdated = false
		end
		local tempXDir = level4_Animation.xDirection / math.sqrt((math.pow(level4_Animation.xDirection, 2) + math.pow(level4_Animation.yDirection, 2)))
		local tempYDir = level4_Animation.yDirection / math.sqrt((math.pow(level4_Animation.xDirection, 2) + math.pow(level4_Animation.yDirection, 2)))
		level4_Animation.xDirection = tempXDir
		level4_Animation.yDirection = tempYDir
	end
	if level1_Animation ~= nil then
		if level1_Animation.hasBody == true then
			local vx, vy = level1_Animation:getLinearVelocity()
			level1_Animation.xCurrentSpeed = vx
			level1_Animation.yCurrentSpeed = vy
			if level1_Animation.xSpeedUpdated == true then
				level1_Animation:setLinearVelocity(level1_Animation.xSpeed, vy)
				level1_Animation.xSpeedUpdated = false
			end
			if level1_Animation.ySpeedUpdated == true then
				local vx2, vy2 = level1_Animation:getLinearVelocity()
				level1_Animation:setLinearVelocity(vx2, level1_Animation.ySpeed)
				level1_Animation.ySpeedUpdated = false
			end
			local vx3, vy3 = level1_Animation:getLinearVelocity()
			level1_Animation.xSpeed = vx3
			level1_Animation.ySpeed = vy3
		elseif level1_Animation.hasBody == false then
			level1_Animation.x = level1_Animation.x + level1_Animation.xSpeed * deltaTime * 0.001
			level1_Animation.y = level1_Animation.y + level1_Animation.ySpeed * deltaTime * 0.001
			level1_Animation.xCurrentSpeed = level1_Animation.xSpeed
			level1_Animation.yCurrentSpeed = level1_Animation.ySpeed
		end
		if level1_Animation.xDirection == 0 and level1_Animation.yDirection == 0 then
			level1_Animation.xDirection = 1
			level1_Animation.yDirection = 0
		end
		if level1_Animation.rotationUpdated == true then
			level1_Animation.xDirection = math.cos(level1_Animation.rotation * math.pi / 180)
			level1_Animation.yDirection = math.sin(level1_Animation.rotation * math.pi / 180)
			level1_Animation.rotationUpdated = false
		end
		if level1_Animation.directionUpdated == true then
			level1_Animation.rotation = ((math.atan2(level1_Animation.yDirection, level1_Animation.xDirection) * 180 / math.pi) + 720) % 360
			level1_Animation.directionUpdated = false
		end
		local tempXDir = level1_Animation.xDirection / math.sqrt((math.pow(level1_Animation.xDirection, 2) + math.pow(level1_Animation.yDirection, 2)))
		local tempYDir = level1_Animation.yDirection / math.sqrt((math.pow(level1_Animation.xDirection, 2) + math.pow(level1_Animation.yDirection, 2)))
		level1_Animation.xDirection = tempXDir
		level1_Animation.yDirection = tempYDir
	end
	if backButton_Sprite ~= nil then
		if backButton_Sprite.hasBody == true then
			local vx, vy = backButton_Sprite:getLinearVelocity()
			backButton_Sprite.xCurrentSpeed = vx
			backButton_Sprite.yCurrentSpeed = vy
			if backButton_Sprite.xSpeedUpdated == true then
				backButton_Sprite:setLinearVelocity(backButton_Sprite.xSpeed, vy)
				backButton_Sprite.xSpeedUpdated = false
			end
			if backButton_Sprite.ySpeedUpdated == true then
				local vx2, vy2 = backButton_Sprite:getLinearVelocity()
				backButton_Sprite:setLinearVelocity(vx2, backButton_Sprite.ySpeed)
				backButton_Sprite.ySpeedUpdated = false
			end
			local vx3, vy3 = backButton_Sprite:getLinearVelocity()
			backButton_Sprite.xSpeed = vx3
			backButton_Sprite.ySpeed = vy3
		elseif backButton_Sprite.hasBody == false then
			backButton_Sprite.x = backButton_Sprite.x + backButton_Sprite.xSpeed * deltaTime * 0.001
			backButton_Sprite.y = backButton_Sprite.y + backButton_Sprite.ySpeed * deltaTime * 0.001
			backButton_Sprite.xCurrentSpeed = backButton_Sprite.xSpeed
			backButton_Sprite.yCurrentSpeed = backButton_Sprite.ySpeed
		end
		if backButton_Sprite.xDirection == 0 and backButton_Sprite.yDirection == 0 then
			backButton_Sprite.xDirection = 1
			backButton_Sprite.yDirection = 0
		end
		if backButton_Sprite.rotationUpdated == true then
			backButton_Sprite.xDirection = math.cos(backButton_Sprite.rotation * math.pi / 180)
			backButton_Sprite.yDirection = math.sin(backButton_Sprite.rotation * math.pi / 180)
			backButton_Sprite.rotationUpdated = false
		end
		if backButton_Sprite.directionUpdated == true then
			backButton_Sprite.rotation = ((math.atan2(backButton_Sprite.yDirection, backButton_Sprite.xDirection) * 180 / math.pi) + 720) % 360
			backButton_Sprite.directionUpdated = false
		end
		local tempXDir = backButton_Sprite.xDirection / math.sqrt((math.pow(backButton_Sprite.xDirection, 2) + math.pow(backButton_Sprite.yDirection, 2)))
		local tempYDir = backButton_Sprite.yDirection / math.sqrt((math.pow(backButton_Sprite.xDirection, 2) + math.pow(backButton_Sprite.yDirection, 2)))
		backButton_Sprite.xDirection = tempXDir
		backButton_Sprite.yDirection = tempYDir
	end
	if levelsBackground_Sprite ~= nil then
		if levelsBackground_Sprite.hasBody == true then
			local vx, vy = levelsBackground_Sprite:getLinearVelocity()
			levelsBackground_Sprite.xCurrentSpeed = vx
			levelsBackground_Sprite.yCurrentSpeed = vy
			if levelsBackground_Sprite.xSpeedUpdated == true then
				levelsBackground_Sprite:setLinearVelocity(levelsBackground_Sprite.xSpeed, vy)
				levelsBackground_Sprite.xSpeedUpdated = false
			end
			if levelsBackground_Sprite.ySpeedUpdated == true then
				local vx2, vy2 = levelsBackground_Sprite:getLinearVelocity()
				levelsBackground_Sprite:setLinearVelocity(vx2, levelsBackground_Sprite.ySpeed)
				levelsBackground_Sprite.ySpeedUpdated = false
			end
			local vx3, vy3 = levelsBackground_Sprite:getLinearVelocity()
			levelsBackground_Sprite.xSpeed = vx3
			levelsBackground_Sprite.ySpeed = vy3
		elseif levelsBackground_Sprite.hasBody == false then
			levelsBackground_Sprite.x = levelsBackground_Sprite.x + levelsBackground_Sprite.xSpeed * deltaTime * 0.001
			levelsBackground_Sprite.y = levelsBackground_Sprite.y + levelsBackground_Sprite.ySpeed * deltaTime * 0.001
			levelsBackground_Sprite.xCurrentSpeed = levelsBackground_Sprite.xSpeed
			levelsBackground_Sprite.yCurrentSpeed = levelsBackground_Sprite.ySpeed
		end
		if levelsBackground_Sprite.xDirection == 0 and levelsBackground_Sprite.yDirection == 0 then
			levelsBackground_Sprite.xDirection = 1
			levelsBackground_Sprite.yDirection = 0
		end
		if levelsBackground_Sprite.rotationUpdated == true then
			levelsBackground_Sprite.xDirection = math.cos(levelsBackground_Sprite.rotation * math.pi / 180)
			levelsBackground_Sprite.yDirection = math.sin(levelsBackground_Sprite.rotation * math.pi / 180)
			levelsBackground_Sprite.rotationUpdated = false
		end
		if levelsBackground_Sprite.directionUpdated == true then
			levelsBackground_Sprite.rotation = ((math.atan2(levelsBackground_Sprite.yDirection, levelsBackground_Sprite.xDirection) * 180 / math.pi) + 720) % 360
			levelsBackground_Sprite.directionUpdated = false
		end
		local tempXDir = levelsBackground_Sprite.xDirection / math.sqrt((math.pow(levelsBackground_Sprite.xDirection, 2) + math.pow(levelsBackground_Sprite.yDirection, 2)))
		local tempYDir = levelsBackground_Sprite.yDirection / math.sqrt((math.pow(levelsBackground_Sprite.xDirection, 2) + math.pow(levelsBackground_Sprite.yDirection, 2)))
		levelsBackground_Sprite.xDirection = tempXDir
		levelsBackground_Sprite.yDirection = tempYDir
	end
	if level3_Animation ~= nil then
		if level3_Animation.hasBody == true then
			local vx, vy = level3_Animation:getLinearVelocity()
			level3_Animation.xCurrentSpeed = vx
			level3_Animation.yCurrentSpeed = vy
			if level3_Animation.xSpeedUpdated == true then
				level3_Animation:setLinearVelocity(level3_Animation.xSpeed, vy)
				level3_Animation.xSpeedUpdated = false
			end
			if level3_Animation.ySpeedUpdated == true then
				local vx2, vy2 = level3_Animation:getLinearVelocity()
				level3_Animation:setLinearVelocity(vx2, level3_Animation.ySpeed)
				level3_Animation.ySpeedUpdated = false
			end
			local vx3, vy3 = level3_Animation:getLinearVelocity()
			level3_Animation.xSpeed = vx3
			level3_Animation.ySpeed = vy3
		elseif level3_Animation.hasBody == false then
			level3_Animation.x = level3_Animation.x + level3_Animation.xSpeed * deltaTime * 0.001
			level3_Animation.y = level3_Animation.y + level3_Animation.ySpeed * deltaTime * 0.001
			level3_Animation.xCurrentSpeed = level3_Animation.xSpeed
			level3_Animation.yCurrentSpeed = level3_Animation.ySpeed
		end
		if level3_Animation.xDirection == 0 and level3_Animation.yDirection == 0 then
			level3_Animation.xDirection = 1
			level3_Animation.yDirection = 0
		end
		if level3_Animation.rotationUpdated == true then
			level3_Animation.xDirection = math.cos(level3_Animation.rotation * math.pi / 180)
			level3_Animation.yDirection = math.sin(level3_Animation.rotation * math.pi / 180)
			level3_Animation.rotationUpdated = false
		end
		if level3_Animation.directionUpdated == true then
			level3_Animation.rotation = ((math.atan2(level3_Animation.yDirection, level3_Animation.xDirection) * 180 / math.pi) + 720) % 360
			level3_Animation.directionUpdated = false
		end
		local tempXDir = level3_Animation.xDirection / math.sqrt((math.pow(level3_Animation.xDirection, 2) + math.pow(level3_Animation.yDirection, 2)))
		local tempYDir = level3_Animation.yDirection / math.sqrt((math.pow(level3_Animation.xDirection, 2) + math.pow(level3_Animation.yDirection, 2)))
		level3_Animation.xDirection = tempXDir
		level3_Animation.yDirection = tempYDir
	end
	if level2_Animation ~= nil then
		if level2_Animation.hasBody == true then
			local vx, vy = level2_Animation:getLinearVelocity()
			level2_Animation.xCurrentSpeed = vx
			level2_Animation.yCurrentSpeed = vy
			if level2_Animation.xSpeedUpdated == true then
				level2_Animation:setLinearVelocity(level2_Animation.xSpeed, vy)
				level2_Animation.xSpeedUpdated = false
			end
			if level2_Animation.ySpeedUpdated == true then
				local vx2, vy2 = level2_Animation:getLinearVelocity()
				level2_Animation:setLinearVelocity(vx2, level2_Animation.ySpeed)
				level2_Animation.ySpeedUpdated = false
			end
			local vx3, vy3 = level2_Animation:getLinearVelocity()
			level2_Animation.xSpeed = vx3
			level2_Animation.ySpeed = vy3
		elseif level2_Animation.hasBody == false then
			level2_Animation.x = level2_Animation.x + level2_Animation.xSpeed * deltaTime * 0.001
			level2_Animation.y = level2_Animation.y + level2_Animation.ySpeed * deltaTime * 0.001
			level2_Animation.xCurrentSpeed = level2_Animation.xSpeed
			level2_Animation.yCurrentSpeed = level2_Animation.ySpeed
		end
		if level2_Animation.xDirection == 0 and level2_Animation.yDirection == 0 then
			level2_Animation.xDirection = 1
			level2_Animation.yDirection = 0
		end
		if level2_Animation.rotationUpdated == true then
			level2_Animation.xDirection = math.cos(level2_Animation.rotation * math.pi / 180)
			level2_Animation.yDirection = math.sin(level2_Animation.rotation * math.pi / 180)
			level2_Animation.rotationUpdated = false
		end
		if level2_Animation.directionUpdated == true then
			level2_Animation.rotation = ((math.atan2(level2_Animation.yDirection, level2_Animation.xDirection) * 180 / math.pi) + 720) % 360
			level2_Animation.directionUpdated = false
		end
		local tempXDir = level2_Animation.xDirection / math.sqrt((math.pow(level2_Animation.xDirection, 2) + math.pow(level2_Animation.yDirection, 2)))
		local tempYDir = level2_Animation.yDirection / math.sqrt((math.pow(level2_Animation.xDirection, 2) + math.pow(level2_Animation.yDirection, 2)))
		level2_Animation.xDirection = tempXDir
		level2_Animation.yDirection = tempYDir
	end
end

menuInCompleted = function (obj)
	LevelsScreen.addButtonEventListeners()
	Runtime:addEventListener("enterFrame", onEnterFrame)
	Runtime:addEventListener("touch", onScreenTouch)
	Runtime:addEventListener("collision", onCollision)

	if var_isLevel2Locked == true then
		if level2_Animation ~= nil then
			if level2_Animation.sequence ~= "levelLocked" then
				level2_Animation:setSequence("levelLocked")
				level2_Animation:play()
			end
		end
	end
	if var_isLevel3Locked == true then
		if level3_Animation ~= nil then
			if level3_Animation.sequence ~= "levelLocked" then
				level3_Animation:setSequence("levelLocked")
				level3_Animation:play()
			end
		end
	end
	if var_isLevel4Locked == true then
		if level4_Animation ~= nil then
			if level4_Animation.sequence ~= "levelLocked" then
				level4_Animation:setSequence("levelLocked")
				level4_Animation:play()
			end
		end
	end
	if var_isLevel5Locked == true then
		if level5_Animation ~= nil then
			if level5_Animation.sequence ~= "levelLocked" then
				level5_Animation:setSequence("levelLocked")
				level5_Animation:play()
			end
		end
	end
	soundList["musicSoft"].play(-1)

end

function LevelsScreen.menuIn ()

	loadScreen()

	transition.to(screenHolder, {time = 10, onComplete = menuInCompleted})

	camera.boundedObject = nil
	mTimerList = {}
	timerCount = 0
end

function LevelsScreen.removeButtonEventListeners ()
	if level5_Animation ~= nil then
		display.getCurrentStage():setFocus( level5_Animation, nil )
		level5_Animation.touch = level5_AnimationTouchHandler
		level5_Animation:removeEventListener("touch", level5_Animation)
	end

	if level4_Animation ~= nil then
		display.getCurrentStage():setFocus( level4_Animation, nil )
		level4_Animation.touch = level4_AnimationTouchHandler
		level4_Animation:removeEventListener("touch", level4_Animation)
	end

	if level1_Animation ~= nil then
		display.getCurrentStage():setFocus( level1_Animation, nil )
		level1_Animation.touch = level1_AnimationTouchHandler
		level1_Animation:removeEventListener("touch", level1_Animation)
	end

	if backButton_Sprite ~= nil then
		display.getCurrentStage():setFocus( backButton_Sprite, nil )
		backButton_Sprite.touch = backButton_SpriteTouchHandler
		backButton_Sprite:removeEventListener("touch", backButton_Sprite)
	end

	if level3_Animation ~= nil then
		display.getCurrentStage():setFocus( level3_Animation, nil )
		level3_Animation.touch = level3_AnimationTouchHandler
		level3_Animation:removeEventListener("touch", level3_Animation)
	end

	if level2_Animation ~= nil then
		display.getCurrentStage():setFocus( level2_Animation, nil )
		level2_Animation.touch = level2_AnimationTouchHandler
		level2_Animation:removeEventListener("touch", level2_Animation)
	end

end

menuOutCompleted = function ( nextScreenId, isNextScreenPopUp )
	if isNextScreenPopUp == true then
	else
		display.remove(screenHolder)
		screenHolder = nil

	end
	NextScreenId = nextScreenId
	PreviousScreenId = LevelsScreenMenuID
	changeMenu(NextScreenId, PreviousScreenId, false, isNextScreenPopUp)
end

menuOut = function ( nextScreenId, isNextScreenPopUp )
	Runtime:removeEventListener("enterFrame", onEnterFrame)
	Runtime:removeEventListener("touch", onScreenTouch)
	Runtime:removeEventListener("collision", onCollision)

	for i=1, timerCount, 1 do
		if mTimerList[i] ~= nil then
			timer.cancel(mTimerList[i])
		end
	end
	mTimerList = {}
	timerCount = 0

	LevelsScreen.removeButtonEventListeners()
	if isNextScreenPopUp == true then
		transition.to(screenHolder, {time = 10, onComplete = function () menuOutCompleted(nextScreenId, isNextScreenPopUp) end})
	else
		transition.to(screenHolder, {time = 10, onComplete = function () menuOutCompleted(nextScreenId, isNextScreenPopUp) end})
	end
end

return LevelsScreen
