local MainScreen = {}

local playButton_Sprite
local mainScreenBackground_Sprite
local creditsButton_Sprite
local screenHolder
local buttonPressEnabled
local menuInCompleted
local menuOut
local menuOutCompleted
local addButtonEventListeners
local removeButtonEventListeners

local mTimerList
local timerCount


local destroy_playButton_Sprite
local destroy_mainScreenBackground_Sprite
local destroy_creditsButton_Sprite

local camera = {}
camera.boundedObject = nil
camera.leftBound = display.contentWidth * 0
camera.rightBound = display.contentWidth * 1
camera.topBound = display.contentHeight * 0
camera.bottomBound = display.contentHeight * 1
camera.initialHolderLeft = 0
camera.initialHolderRight = 0
camera.initialHolderTop = 0
camera.initialHolderBottom = 0
camera.initialHolderWidth = 0
camera.initialHolderHeight = 0

local leftBoundValue = 0
local rightBoundValue = 0
local topBoundValue = 0
local bottomBoundValue = 0

destroy_playButton_Sprite = function ()
	display.remove(playButton_Sprite)
	playButton_Sprite = nil
end

destroy_mainScreenBackground_Sprite = function ()
	display.remove(mainScreenBackground_Sprite)
	mainScreenBackground_Sprite = nil
end

destroy_creditsButton_Sprite = function ()
	display.remove(creditsButton_Sprite)
	creditsButton_Sprite = nil
end

local startingXPos = 0
local startingYPos = 0
local function onScreenTouch(event)
	if event.phase == "began" then
		startingXPos = event.x
		startingYPos = event.y
	elseif event.phase == "moved" then
	elseif event.phase == "ended" or event.phase == "cancelled" then

		if event.x - startingXPos < -20 and math.abs(event.y - startingYPos) < math.abs(event.x - startingXPos) then
		end

		if event.x - startingXPos > 20 and math.abs(event.y - startingYPos) < math.abs(event.x - startingXPos) then
		end

		if event.y - startingYPos < -20 and math.abs(event.x - startingXPos) < math.abs(event.y - startingYPos) then
		end

		if event.y - startingYPos > 20 and math.abs(event.x - startingXPos) < math.abs(event.y - startingYPos) then
		end
	end
end

local function onAccelerometer(event)
end

local function onCollision( event )
	if ( event.phase == "began" ) then
	elseif ( event.phase == "ended" ) then
	end
end

local function playButton_SpriteTouchHandler(self, event)
	if event.phase == "began" then
		event.target.pressed = true
		display.getCurrentStage():setFocus( event.target, event.id )
		event.target.focus = true
	elseif event.phase == "moved" then
	elseif (event.phase == "ended" or event.phase == "cancelled") and event.target.pressed == true then
		if event.target.focus ~= true then
			return false
		end
		display.getCurrentStage():setFocus( event.target, nil )
		menuOut ( LevelsScreenMenuID )
	end
	return true
end

local function creditsButton_SpriteTouchHandler(self, event)
	if event.phase == "began" then
		event.target.pressed = true
		display.getCurrentStage():setFocus( event.target, event.id )
		event.target.focus = true
	elseif event.phase == "moved" then
	elseif (event.phase == "ended" or event.phase == "cancelled") and event.target.pressed == true then
		if event.target.focus ~= true then
			return false
		end
		display.getCurrentStage():setFocus( event.target, nil )
		menuOut ( CreditsScreenMenuID )
	end
	return true
end

local function loadScreen ()
	screenHolder = display.newGroup()
	screenHolder.x = 0
	screenHolder.y = 0
	local screenHolderRect = display.newRect(screenHolder, 0, 0, display.contentWidth, display.contentHeight)
	screenHolderRect.alpha = 0

	cameraHolder = display.newGroup()
	cameraHolder.x = 0
	cameraHolder.y = 0

	buttonPressEnabled = true

	display.remove(playButton_Sprite)
	playButton_Sprite = nil
	playButton_Sprite = display.newImageRect("playButton.png", 490, 497)
	playButton_Sprite.anchorX = 0.5
	playButton_Sprite.anchorY = 0.5
	playButton_Sprite.hasBody = false
	playButton_Sprite.x = 1786.8500000000058 + 0 + 0
	playButton_Sprite.y = 1274.6999999999969 + 0 + 0
	playButton_Sprite.xScale = 1
	playButton_Sprite.yScale = 1
	playButton_Sprite.alpha = 1
	playButton_Sprite.rotation = 0
	playButton_Sprite.xDirection = 1
	playButton_Sprite.yDirection = 0
	playButton_Sprite.xSpeed = 0
	playButton_Sprite.ySpeed = 0
	playButton_Sprite.xCurrentSpeed = 0
	playButton_Sprite.yCurrentSpeed = 0
	playButton_Sprite.xSpeedUpdated = false
	playButton_Sprite.ySpeedUpdated = false
	playButton_Sprite.rotationUpdated = false
	playButton_Sprite.directionUpdated = false
	playButton_Sprite.spawnIndex = 1

	display.remove(mainScreenBackground_Sprite)
	mainScreenBackground_Sprite = nil
	mainScreenBackground_Sprite = display.newImageRect("mainScreenBackground.png", 2048, 1536)
	mainScreenBackground_Sprite.anchorX = 0.5
	mainScreenBackground_Sprite.anchorY = 0.5
	mainScreenBackground_Sprite.hasBody = false
	mainScreenBackground_Sprite.x = 1024 + 0 + 0
	mainScreenBackground_Sprite.y = 768 + 0 + 0
	mainScreenBackground_Sprite.xScale = 1
	mainScreenBackground_Sprite.yScale = 1
	mainScreenBackground_Sprite.alpha = 1
	mainScreenBackground_Sprite.rotation = 0
	mainScreenBackground_Sprite.xDirection = 1
	mainScreenBackground_Sprite.yDirection = 0
	mainScreenBackground_Sprite.xSpeed = 0
	mainScreenBackground_Sprite.ySpeed = 0
	mainScreenBackground_Sprite.xCurrentSpeed = 0
	mainScreenBackground_Sprite.yCurrentSpeed = 0
	mainScreenBackground_Sprite.xSpeedUpdated = false
	mainScreenBackground_Sprite.ySpeedUpdated = false
	mainScreenBackground_Sprite.rotationUpdated = false
	mainScreenBackground_Sprite.directionUpdated = false
	mainScreenBackground_Sprite.spawnIndex = 1

	display.remove(creditsButton_Sprite)
	creditsButton_Sprite = nil
	creditsButton_Sprite = display.newImageRect("creditsButton.png", 503, 503)
	creditsButton_Sprite.anchorX = 0.5
	creditsButton_Sprite.anchorY = 0.5
	creditsButton_Sprite.hasBody = false
	creditsButton_Sprite.x = 261.9499999999971 + 0 + 0
	creditsButton_Sprite.y = 1279.949999999997 + 0 + 0
	creditsButton_Sprite.xScale = 1
	creditsButton_Sprite.yScale = 1
	creditsButton_Sprite.alpha = 1
	creditsButton_Sprite.rotation = 0
	creditsButton_Sprite.xDirection = 1
	creditsButton_Sprite.yDirection = 0
	creditsButton_Sprite.xSpeed = 0
	creditsButton_Sprite.ySpeed = 0
	creditsButton_Sprite.xCurrentSpeed = 0
	creditsButton_Sprite.yCurrentSpeed = 0
	creditsButton_Sprite.xSpeedUpdated = false
	creditsButton_Sprite.ySpeedUpdated = false
	creditsButton_Sprite.rotationUpdated = false
	creditsButton_Sprite.directionUpdated = false
	creditsButton_Sprite.spawnIndex = 1

	cameraHolder:insert(mainScreenBackground_Sprite)
	cameraHolder:insert(playButton_Sprite)
	cameraHolder:insert(creditsButton_Sprite)

	screenHolder:insert( cameraHolder )
	screenHolder.anchorX = 0
	screenHolder.anchorY = 0

	leftBoundObject = mainScreenBackground_Sprite
	leftBoundValue = 0
	rightBoundObject = mainScreenBackground_Sprite
	rightBoundValue = 2048
	topBoundObject = mainScreenBackground_Sprite
	topBoundValue = 0
	bottomBoundObject = mainScreenBackground_Sprite
	bottomBoundValue = 1536

	camera.initialHolderLeft = leftBoundValue
	camera.initialHolderRight = camera.initialHolderLeft + cameraHolder.width
	camera.initialHolderTop = topBoundValue
	camera.initialHolderBottom = camera.initialHolderTop + cameraHolder.height
	camera.initialHolderWidth = cameraHolder.width
	camera.initialHolderHeight = cameraHolder.height
end

function MainScreen.addButtonEventListeners ()
	playButton_Sprite.touch = playButton_SpriteTouchHandler
	playButton_Sprite:addEventListener("touch", playButton_Sprite)

	creditsButton_Sprite.touch = creditsButton_SpriteTouchHandler
	creditsButton_Sprite:addEventListener("touch", creditsButton_Sprite)

end

local function onEnterFrame(event)
	deltaTime = system.getTimer() - currentTime
	if deltaTime > 1000 then
		deltaTime = 1000/60
	elseif deltaTime < 0 then
		deltaTime = 1000/60
	end
	currentTime = system.getTimer()


	if camera.boundedObject ~= nil then
		if (cameraHolder.x + camera.boundedObject.x >= camera.rightBound) then
			if cameraHolder.x + camera.initialHolderWidth + camera.initialHolderLeft > display.contentWidth then
				cameraHolder.x = camera.rightBound - camera.boundedObject.x
			end
		elseif (cameraHolder.x + camera.boundedObject.x <= camera.leftBound) then
			if cameraHolder.x + camera.initialHolderLeft < 0 then
				cameraHolder.x = camera.leftBound - camera.boundedObject.x
			end
		end

		if (cameraHolder.y + camera.boundedObject.y >= camera.bottomBound) then
			if cameraHolder.y + camera.initialHolderHeight + camera.initialHolderTop > display.contentHeight then
				cameraHolder.y = camera.bottomBound - camera.boundedObject.y
			end
		elseif (cameraHolder.y + camera.boundedObject.y <= camera.topBound) then
			if cameraHolder.y + camera.initialHolderTop < 0 then
				cameraHolder.y = camera.topBound - camera.boundedObject.y
			end
		end
	end


	if playButton_Sprite ~= nil then
		if playButton_Sprite.hasBody == true then
			local vx, vy = playButton_Sprite:getLinearVelocity()
			playButton_Sprite.xCurrentSpeed = vx
			playButton_Sprite.yCurrentSpeed = vy
			if playButton_Sprite.xSpeedUpdated == true then
				playButton_Sprite:setLinearVelocity(playButton_Sprite.xSpeed, vy)
				playButton_Sprite.xSpeedUpdated = false
			end
			if playButton_Sprite.ySpeedUpdated == true then
				local vx2, vy2 = playButton_Sprite:getLinearVelocity()
				playButton_Sprite:setLinearVelocity(vx2, playButton_Sprite.ySpeed)
				playButton_Sprite.ySpeedUpdated = false
			end
			local vx3, vy3 = playButton_Sprite:getLinearVelocity()
			playButton_Sprite.xSpeed = vx3
			playButton_Sprite.ySpeed = vy3
		elseif playButton_Sprite.hasBody == false then
			playButton_Sprite.x = playButton_Sprite.x + playButton_Sprite.xSpeed * deltaTime * 0.001
			playButton_Sprite.y = playButton_Sprite.y + playButton_Sprite.ySpeed * deltaTime * 0.001
			playButton_Sprite.xCurrentSpeed = playButton_Sprite.xSpeed
			playButton_Sprite.yCurrentSpeed = playButton_Sprite.ySpeed
		end
		if playButton_Sprite.xDirection == 0 and playButton_Sprite.yDirection == 0 then
			playButton_Sprite.xDirection = 1
			playButton_Sprite.yDirection = 0
		end
		if playButton_Sprite.rotationUpdated == true then
			playButton_Sprite.xDirection = math.cos(playButton_Sprite.rotation * math.pi / 180)
			playButton_Sprite.yDirection = math.sin(playButton_Sprite.rotation * math.pi / 180)
			playButton_Sprite.rotationUpdated = false
		end
		if playButton_Sprite.directionUpdated == true then
			playButton_Sprite.rotation = ((math.atan2(playButton_Sprite.yDirection, playButton_Sprite.xDirection) * 180 / math.pi) + 720) % 360
			playButton_Sprite.directionUpdated = false
		end
		local tempXDir = playButton_Sprite.xDirection / math.sqrt((math.pow(playButton_Sprite.xDirection, 2) + math.pow(playButton_Sprite.yDirection, 2)))
		local tempYDir = playButton_Sprite.yDirection / math.sqrt((math.pow(playButton_Sprite.xDirection, 2) + math.pow(playButton_Sprite.yDirection, 2)))
		playButton_Sprite.xDirection = tempXDir
		playButton_Sprite.yDirection = tempYDir
	end
	if mainScreenBackground_Sprite ~= nil then
		if mainScreenBackground_Sprite.hasBody == true then
			local vx, vy = mainScreenBackground_Sprite:getLinearVelocity()
			mainScreenBackground_Sprite.xCurrentSpeed = vx
			mainScreenBackground_Sprite.yCurrentSpeed = vy
			if mainScreenBackground_Sprite.xSpeedUpdated == true then
				mainScreenBackground_Sprite:setLinearVelocity(mainScreenBackground_Sprite.xSpeed, vy)
				mainScreenBackground_Sprite.xSpeedUpdated = false
			end
			if mainScreenBackground_Sprite.ySpeedUpdated == true then
				local vx2, vy2 = mainScreenBackground_Sprite:getLinearVelocity()
				mainScreenBackground_Sprite:setLinearVelocity(vx2, mainScreenBackground_Sprite.ySpeed)
				mainScreenBackground_Sprite.ySpeedUpdated = false
			end
			local vx3, vy3 = mainScreenBackground_Sprite:getLinearVelocity()
			mainScreenBackground_Sprite.xSpeed = vx3
			mainScreenBackground_Sprite.ySpeed = vy3
		elseif mainScreenBackground_Sprite.hasBody == false then
			mainScreenBackground_Sprite.x = mainScreenBackground_Sprite.x + mainScreenBackground_Sprite.xSpeed * deltaTime * 0.001
			mainScreenBackground_Sprite.y = mainScreenBackground_Sprite.y + mainScreenBackground_Sprite.ySpeed * deltaTime * 0.001
			mainScreenBackground_Sprite.xCurrentSpeed = mainScreenBackground_Sprite.xSpeed
			mainScreenBackground_Sprite.yCurrentSpeed = mainScreenBackground_Sprite.ySpeed
		end
		if mainScreenBackground_Sprite.xDirection == 0 and mainScreenBackground_Sprite.yDirection == 0 then
			mainScreenBackground_Sprite.xDirection = 1
			mainScreenBackground_Sprite.yDirection = 0
		end
		if mainScreenBackground_Sprite.rotationUpdated == true then
			mainScreenBackground_Sprite.xDirection = math.cos(mainScreenBackground_Sprite.rotation * math.pi / 180)
			mainScreenBackground_Sprite.yDirection = math.sin(mainScreenBackground_Sprite.rotation * math.pi / 180)
			mainScreenBackground_Sprite.rotationUpdated = false
		end
		if mainScreenBackground_Sprite.directionUpdated == true then
			mainScreenBackground_Sprite.rotation = ((math.atan2(mainScreenBackground_Sprite.yDirection, mainScreenBackground_Sprite.xDirection) * 180 / math.pi) + 720) % 360
			mainScreenBackground_Sprite.directionUpdated = false
		end
		local tempXDir = mainScreenBackground_Sprite.xDirection / math.sqrt((math.pow(mainScreenBackground_Sprite.xDirection, 2) + math.pow(mainScreenBackground_Sprite.yDirection, 2)))
		local tempYDir = mainScreenBackground_Sprite.yDirection / math.sqrt((math.pow(mainScreenBackground_Sprite.xDirection, 2) + math.pow(mainScreenBackground_Sprite.yDirection, 2)))
		mainScreenBackground_Sprite.xDirection = tempXDir
		mainScreenBackground_Sprite.yDirection = tempYDir
	end
	if creditsButton_Sprite ~= nil then
		if creditsButton_Sprite.hasBody == true then
			local vx, vy = creditsButton_Sprite:getLinearVelocity()
			creditsButton_Sprite.xCurrentSpeed = vx
			creditsButton_Sprite.yCurrentSpeed = vy
			if creditsButton_Sprite.xSpeedUpdated == true then
				creditsButton_Sprite:setLinearVelocity(creditsButton_Sprite.xSpeed, vy)
				creditsButton_Sprite.xSpeedUpdated = false
			end
			if creditsButton_Sprite.ySpeedUpdated == true then
				local vx2, vy2 = creditsButton_Sprite:getLinearVelocity()
				creditsButton_Sprite:setLinearVelocity(vx2, creditsButton_Sprite.ySpeed)
				creditsButton_Sprite.ySpeedUpdated = false
			end
			local vx3, vy3 = creditsButton_Sprite:getLinearVelocity()
			creditsButton_Sprite.xSpeed = vx3
			creditsButton_Sprite.ySpeed = vy3
		elseif creditsButton_Sprite.hasBody == false then
			creditsButton_Sprite.x = creditsButton_Sprite.x + creditsButton_Sprite.xSpeed * deltaTime * 0.001
			creditsButton_Sprite.y = creditsButton_Sprite.y + creditsButton_Sprite.ySpeed * deltaTime * 0.001
			creditsButton_Sprite.xCurrentSpeed = creditsButton_Sprite.xSpeed
			creditsButton_Sprite.yCurrentSpeed = creditsButton_Sprite.ySpeed
		end
		if creditsButton_Sprite.xDirection == 0 and creditsButton_Sprite.yDirection == 0 then
			creditsButton_Sprite.xDirection = 1
			creditsButton_Sprite.yDirection = 0
		end
		if creditsButton_Sprite.rotationUpdated == true then
			creditsButton_Sprite.xDirection = math.cos(creditsButton_Sprite.rotation * math.pi / 180)
			creditsButton_Sprite.yDirection = math.sin(creditsButton_Sprite.rotation * math.pi / 180)
			creditsButton_Sprite.rotationUpdated = false
		end
		if creditsButton_Sprite.directionUpdated == true then
			creditsButton_Sprite.rotation = ((math.atan2(creditsButton_Sprite.yDirection, creditsButton_Sprite.xDirection) * 180 / math.pi) + 720) % 360
			creditsButton_Sprite.directionUpdated = false
		end
		local tempXDir = creditsButton_Sprite.xDirection / math.sqrt((math.pow(creditsButton_Sprite.xDirection, 2) + math.pow(creditsButton_Sprite.yDirection, 2)))
		local tempYDir = creditsButton_Sprite.yDirection / math.sqrt((math.pow(creditsButton_Sprite.xDirection, 2) + math.pow(creditsButton_Sprite.yDirection, 2)))
		creditsButton_Sprite.xDirection = tempXDir
		creditsButton_Sprite.yDirection = tempYDir
	end
end

menuInCompleted = function (obj)
	MainScreen.addButtonEventListeners()
	Runtime:addEventListener("enterFrame", onEnterFrame)
	Runtime:addEventListener("touch", onScreenTouch)
	Runtime:addEventListener("collision", onCollision)

end

function MainScreen.menuIn ()

	loadScreen()

	transition.to(screenHolder, {time = 10, onComplete = menuInCompleted})

	camera.boundedObject = nil
	mTimerList = {}
	timerCount = 0
end

function MainScreen.removeButtonEventListeners ()
	if playButton_Sprite ~= nil then
		display.getCurrentStage():setFocus( playButton_Sprite, nil )
		playButton_Sprite.touch = playButton_SpriteTouchHandler
		playButton_Sprite:removeEventListener("touch", playButton_Sprite)
	end

	if creditsButton_Sprite ~= nil then
		display.getCurrentStage():setFocus( creditsButton_Sprite, nil )
		creditsButton_Sprite.touch = creditsButton_SpriteTouchHandler
		creditsButton_Sprite:removeEventListener("touch", creditsButton_Sprite)
	end

end

menuOutCompleted = function ( nextScreenId, isNextScreenPopUp )
	if isNextScreenPopUp == true then
	else
		display.remove(screenHolder)
		screenHolder = nil

	end
	NextScreenId = nextScreenId
	PreviousScreenId = MainScreenMenuID
	changeMenu(NextScreenId, PreviousScreenId, false, isNextScreenPopUp)
end

menuOut = function ( nextScreenId, isNextScreenPopUp )
	Runtime:removeEventListener("enterFrame", onEnterFrame)
	Runtime:removeEventListener("touch", onScreenTouch)
	Runtime:removeEventListener("collision", onCollision)

	for i=1, timerCount, 1 do
		if mTimerList[i] ~= nil then
			timer.cancel(mTimerList[i])
		end
	end
	mTimerList = {}
	timerCount = 0

	MainScreen.removeButtonEventListeners()
	if isNextScreenPopUp == true then
		transition.to(screenHolder, {time = 10, onComplete = function () menuOutCompleted(nextScreenId, isNextScreenPopUp) end})
	else
		transition.to(screenHolder, {time = 10, onComplete = function () menuOutCompleted(nextScreenId, isNextScreenPopUp) end})
	end
end

return MainScreen
