local SplashScreen = {}

local GameLooperLogoHD_Sprite
local screenHolder
local buttonPressEnabled
local menuInCompleted
local menuOut
local menuOutCompleted
local addButtonEventListeners
local removeButtonEventListeners

local mTimerList
local timerCount


local destroy_GameLooperLogoHD_Sprite

local camera = {}
camera.boundedObject = nil
camera.leftBound = display.contentWidth * 0
camera.rightBound = display.contentWidth * 1
camera.topBound = display.contentHeight * 0
camera.bottomBound = display.contentHeight * 1
camera.initialHolderLeft = 0
camera.initialHolderRight = 0
camera.initialHolderTop = 0
camera.initialHolderBottom = 0
camera.initialHolderWidth = 0
camera.initialHolderHeight = 0

local leftBoundValue = 0
local rightBoundValue = 0
local topBoundValue = 0
local bottomBoundValue = 0

destroy_GameLooperLogoHD_Sprite = function ()
	display.remove(GameLooperLogoHD_Sprite)
	GameLooperLogoHD_Sprite = nil
end

local startingXPos = 0
local startingYPos = 0
local function onScreenTouch(event)
	if event.phase == "began" then
		startingXPos = event.x
		startingYPos = event.y
	elseif event.phase == "moved" then
	elseif event.phase == "ended" or event.phase == "cancelled" then

		if event.x - startingXPos < -20 and math.abs(event.y - startingYPos) < math.abs(event.x - startingXPos) then
		end

		if event.x - startingXPos > 20 and math.abs(event.y - startingYPos) < math.abs(event.x - startingXPos) then
		end

		if event.y - startingYPos < -20 and math.abs(event.x - startingXPos) < math.abs(event.y - startingYPos) then
		end

		if event.y - startingYPos > 20 and math.abs(event.x - startingXPos) < math.abs(event.y - startingYPos) then
		end
	end
end

local function onAccelerometer(event)
end

local function onCollision( event )
	if ( event.phase == "began" ) then
	elseif ( event.phase == "ended" ) then
	end
end

local function loadScreen ()
	screenHolder = display.newGroup()
	screenHolder.x = 0
	screenHolder.y = 0
	local screenHolderRect = display.newRect(screenHolder, 0, 0, display.contentWidth, display.contentHeight)
	screenHolderRect.alpha = 0

	cameraHolder = display.newGroup()
	cameraHolder.x = 0
	cameraHolder.y = 0

	buttonPressEnabled = true

	display.remove(GameLooperLogoHD_Sprite)
	GameLooperLogoHD_Sprite = nil
	GameLooperLogoHD_Sprite = display.newImageRect("GameLooperLogoHD.png", 2010, 1610)
	GameLooperLogoHD_Sprite.anchorX = 0.5
	GameLooperLogoHD_Sprite.anchorY = 0.5
	GameLooperLogoHD_Sprite.hasBody = false
	GameLooperLogoHD_Sprite.x = 1024 + 0 + 0
	GameLooperLogoHD_Sprite.y = 768 + 0 + 0
	GameLooperLogoHD_Sprite.xScale = 0.5
	GameLooperLogoHD_Sprite.yScale = 0.5
	GameLooperLogoHD_Sprite.alpha = 1
	GameLooperLogoHD_Sprite.rotation = 0
	GameLooperLogoHD_Sprite.xDirection = 1
	GameLooperLogoHD_Sprite.yDirection = 0
	GameLooperLogoHD_Sprite.xSpeed = 0
	GameLooperLogoHD_Sprite.ySpeed = 0
	GameLooperLogoHD_Sprite.xCurrentSpeed = 0
	GameLooperLogoHD_Sprite.yCurrentSpeed = 0
	GameLooperLogoHD_Sprite.xSpeedUpdated = false
	GameLooperLogoHD_Sprite.ySpeedUpdated = false
	GameLooperLogoHD_Sprite.rotationUpdated = false
	GameLooperLogoHD_Sprite.directionUpdated = false
	GameLooperLogoHD_Sprite.spawnIndex = 1

	cameraHolder:insert(GameLooperLogoHD_Sprite)

	screenHolder:insert( cameraHolder )
	screenHolder.anchorX = 0
	screenHolder.anchorY = 0

	leftBoundObject = GameLooperLogoHD_Sprite
	leftBoundValue = 521.5
	rightBoundObject = GameLooperLogoHD_Sprite
	rightBoundValue = 1526.5
	topBoundObject = GameLooperLogoHD_Sprite
	topBoundValue = 365.5
	bottomBoundObject = GameLooperLogoHD_Sprite
	bottomBoundValue = 1170.5

	camera.initialHolderLeft = leftBoundValue
	camera.initialHolderRight = camera.initialHolderLeft + cameraHolder.width
	camera.initialHolderTop = topBoundValue
	camera.initialHolderBottom = camera.initialHolderTop + cameraHolder.height
	camera.initialHolderWidth = cameraHolder.width
	camera.initialHolderHeight = cameraHolder.height
end

function SplashScreen.addButtonEventListeners ()
end

local function onEnterFrame(event)
	deltaTime = system.getTimer() - currentTime
	if deltaTime > 1000 then
		deltaTime = 1000/60
	elseif deltaTime < 0 then
		deltaTime = 1000/60
	end
	currentTime = system.getTimer()


	if camera.boundedObject ~= nil then
		if (cameraHolder.x + camera.boundedObject.x >= camera.rightBound) then
			if cameraHolder.x + camera.initialHolderWidth + camera.initialHolderLeft > display.contentWidth then
				cameraHolder.x = camera.rightBound - camera.boundedObject.x
			end
		elseif (cameraHolder.x + camera.boundedObject.x <= camera.leftBound) then
			if cameraHolder.x + camera.initialHolderLeft < 0 then
				cameraHolder.x = camera.leftBound - camera.boundedObject.x
			end
		end

		if (cameraHolder.y + camera.boundedObject.y >= camera.bottomBound) then
			if cameraHolder.y + camera.initialHolderHeight + camera.initialHolderTop > display.contentHeight then
				cameraHolder.y = camera.bottomBound - camera.boundedObject.y
			end
		elseif (cameraHolder.y + camera.boundedObject.y <= camera.topBound) then
			if cameraHolder.y + camera.initialHolderTop < 0 then
				cameraHolder.y = camera.topBound - camera.boundedObject.y
			end
		end
	end


	if GameLooperLogoHD_Sprite ~= nil then
		if GameLooperLogoHD_Sprite.hasBody == true then
			local vx, vy = GameLooperLogoHD_Sprite:getLinearVelocity()
			GameLooperLogoHD_Sprite.xCurrentSpeed = vx
			GameLooperLogoHD_Sprite.yCurrentSpeed = vy
			if GameLooperLogoHD_Sprite.xSpeedUpdated == true then
				GameLooperLogoHD_Sprite:setLinearVelocity(GameLooperLogoHD_Sprite.xSpeed, vy)
				GameLooperLogoHD_Sprite.xSpeedUpdated = false
			end
			if GameLooperLogoHD_Sprite.ySpeedUpdated == true then
				local vx2, vy2 = GameLooperLogoHD_Sprite:getLinearVelocity()
				GameLooperLogoHD_Sprite:setLinearVelocity(vx2, GameLooperLogoHD_Sprite.ySpeed)
				GameLooperLogoHD_Sprite.ySpeedUpdated = false
			end
			local vx3, vy3 = GameLooperLogoHD_Sprite:getLinearVelocity()
			GameLooperLogoHD_Sprite.xSpeed = vx3
			GameLooperLogoHD_Sprite.ySpeed = vy3
		elseif GameLooperLogoHD_Sprite.hasBody == false then
			GameLooperLogoHD_Sprite.x = GameLooperLogoHD_Sprite.x + GameLooperLogoHD_Sprite.xSpeed * deltaTime * 0.001
			GameLooperLogoHD_Sprite.y = GameLooperLogoHD_Sprite.y + GameLooperLogoHD_Sprite.ySpeed * deltaTime * 0.001
			GameLooperLogoHD_Sprite.xCurrentSpeed = GameLooperLogoHD_Sprite.xSpeed
			GameLooperLogoHD_Sprite.yCurrentSpeed = GameLooperLogoHD_Sprite.ySpeed
		end
		if GameLooperLogoHD_Sprite.xDirection == 0 and GameLooperLogoHD_Sprite.yDirection == 0 then
			GameLooperLogoHD_Sprite.xDirection = 1
			GameLooperLogoHD_Sprite.yDirection = 0
		end
		if GameLooperLogoHD_Sprite.rotationUpdated == true then
			GameLooperLogoHD_Sprite.xDirection = math.cos(GameLooperLogoHD_Sprite.rotation * math.pi / 180)
			GameLooperLogoHD_Sprite.yDirection = math.sin(GameLooperLogoHD_Sprite.rotation * math.pi / 180)
			GameLooperLogoHD_Sprite.rotationUpdated = false
		end
		if GameLooperLogoHD_Sprite.directionUpdated == true then
			GameLooperLogoHD_Sprite.rotation = ((math.atan2(GameLooperLogoHD_Sprite.yDirection, GameLooperLogoHD_Sprite.xDirection) * 180 / math.pi) + 720) % 360
			GameLooperLogoHD_Sprite.directionUpdated = false
		end
		local tempXDir = GameLooperLogoHD_Sprite.xDirection / math.sqrt((math.pow(GameLooperLogoHD_Sprite.xDirection, 2) + math.pow(GameLooperLogoHD_Sprite.yDirection, 2)))
		local tempYDir = GameLooperLogoHD_Sprite.yDirection / math.sqrt((math.pow(GameLooperLogoHD_Sprite.xDirection, 2) + math.pow(GameLooperLogoHD_Sprite.yDirection, 2)))
		GameLooperLogoHD_Sprite.xDirection = tempXDir
		GameLooperLogoHD_Sprite.yDirection = tempYDir
	end
end

menuInCompleted = function (obj)
	SplashScreen.addButtonEventListeners()
	Runtime:addEventListener("enterFrame", onEnterFrame)
	Runtime:addEventListener("touch", onScreenTouch)
	Runtime:addEventListener("collision", onCollision)

	mTimerList[timerCount+1] = timer.performWithDelay(2000, function ()
		menuOut ( MainScreenMenuID )		end, 1)
	timerCount = timerCount + 1

end

function SplashScreen.menuIn ()

	loadScreen()

	transition.to(screenHolder, {time = 10, onComplete = menuInCompleted})

	camera.boundedObject = nil
	mTimerList = {}
	timerCount = 0
end

function SplashScreen.removeButtonEventListeners ()
end

menuOutCompleted = function ( nextScreenId, isNextScreenPopUp )
	if isNextScreenPopUp == true then
	else
		display.remove(screenHolder)
		screenHolder = nil

	end
	NextScreenId = nextScreenId
	PreviousScreenId = SplashScreenMenuID
	changeMenu(NextScreenId, PreviousScreenId, false, isNextScreenPopUp)
end

menuOut = function ( nextScreenId, isNextScreenPopUp )
	Runtime:removeEventListener("enterFrame", onEnterFrame)
	Runtime:removeEventListener("touch", onScreenTouch)
	Runtime:removeEventListener("collision", onCollision)

	for i=1, timerCount, 1 do
		if mTimerList[i] ~= nil then
			timer.cancel(mTimerList[i])
		end
	end
	mTimerList = {}
	timerCount = 0

	SplashScreen.removeButtonEventListeners()
	if isNextScreenPopUp == true then
		transition.to(screenHolder, {time = 10, onComplete = function () menuOutCompleted(nextScreenId, isNextScreenPopUp) end})
	else
		transition.to(screenHolder, {time = 10, onComplete = function () menuOutCompleted(nextScreenId, isNextScreenPopUp) end})
	end
end

return SplashScreen
